
(eval-when (:compile-toplevel :load-toplevel :execute)
  (require "lj-pkg" (logical-pathname "livejournal:lj-pkg"))
  (require "lj-util" (logical-pathname "livejournal:lj-util"))
  (require "lj" (logical-pathname "livejournal:lj")))

(in-package "LJ")

(defvar *resource-file*
  (merge-pathnames (make-pathname :name ".ljrc")
                   (user-homedir-pathname)))

(export 'post)

(defun prompt-user (prompt)
  (format *standard-output* "~& ~A" prompt)
  (read-line *standard-input*))

(defun get-tmpdir ()
  (or (system::getenv "TMPDIR")
      #+win32 (system::getenv "TEMP")
      (system::getenv "TMP")
      #+win32 "c:/temp/"
      #-win32 "/tmp/"))

(defun generate-tmp-file ()
  (let ((tmpdir (get-tmpdir)))
    (when (not (directory tmpdir))
      (setq tmpdir (concatenate 'string tmpdir "/")))
    (namestring (merge-pathnames (symbol-name (gensym "POST"))
                                 tmpdir))))
(defun get-editor ()
  (or (system::getenv "EDITOR")
      (system::getenv "VISUAL")))

(defun post ()
  (ignore-errors
    (load *resource-file*))
  (let ((editor (get-editor))
        (tmpfile (generate-tmp-file))
        (subject (prompt-user "Subject:"))
        (text ""))
    (lisp:execute editor tmpfile)
    (setq text (read-file tmpfile))
    (delete-file tmpfile)
    (postevent subject text)))
    

(provide 'lj-post)
